"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.devopsGit = void 0;
const devopsCore_1 = require("@thatdevops/core/devopsCore");
const path_1 = __importDefault(require("path"));
function devopsGit() {
    return __awaiter(this, void 0, void 0, function* () {
        const { publishable = false, deployable = false } = (0, devopsCore_1.getDevOpsCore)();
        return [
            {
                label: 'Git',
                children: [
                    {
                        label: 'Commit',
                        script: path_1.default.join(__dirname, 'src/commit'),
                        paramQuestions: [
                            {
                                type: 'string',
                                key: 'commitMessage',
                                question: 'Enter commit message (optional)',
                            },
                            ...(deployable
                                ? [
                                    {
                                        type: 'boolean',
                                        key: 'skipcd',
                                        question: 'Skip CD?',
                                        default: 'y',
                                    },
                                ]
                                : []),
                        ],
                    },
                    {
                        label: 'Commit + Push',
                        script: path_1.default.join(__dirname, 'src/commitPush'),
                        default: true,
                        paramQuestions: [
                            {
                                type: 'string',
                                key: 'commitMessage',
                                question: 'Enter commit message (optional)',
                            },
                            ...(deployable
                                ? [
                                    {
                                        type: 'boolean',
                                        key: 'skipcd',
                                        question: 'Skip CD?',
                                        default: 'y',
                                    },
                                ]
                                : []),
                        ],
                    },
                    ...(publishable
                        ? [
                            {
                                label: 'Commit + Push + Publish',
                                script: path_1.default.join(__dirname, 'src/commitPushPublish'),
                                paramQuestions: [
                                    {
                                        type: 'string',
                                        key: 'commitMessage',
                                        question: 'Enter commit message (optional)',
                                    },
                                    {
                                        type: 'boolean',
                                        key: 'force',
                                        question: 'Force publish?',
                                        default: 'n',
                                    },
                                    {
                                        type: 'stringList',
                                        key: 'bumpType',
                                        question: 'Version bump type?',
                                        list: [
                                            { label: 'Patch', value: 'patch', default: true },
                                            { label: 'Minor', value: 'minor' },
                                            { label: 'Major', value: 'major' },
                                        ],
                                    },
                                    ...(deployable
                                        ? [
                                            {
                                                type: 'boolean',
                                                key: 'skipcd',
                                                question: 'Skip CD?',
                                                default: 'y',
                                            },
                                        ]
                                        : []),
                                ],
                            },
                        ]
                        : []),
                ],
            },
        ];
    });
}
exports.devopsGit = devopsGit;
exports.default = devopsGit;
//# sourceMappingURL=devopsGit.js.map